package upsControl;

/*import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;*/

import upsControl.SMSSendReceive;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;


public class UpsControl extends MIDlet {

	// Символические имена вхоодов и выходов
	final static int GPIO_INPUT_1 = 0; // номер GPIO (GPIO1: 0), соотв. входу 1
	final static int GPIO_INPUT_2 = 1; // номер GPIO (GPIO2: 1), соотв. входу 2
	final static int GPIO_INPUT_3 = 2; // номер GPIO (GPIO3: 2), соотв. входу 3
	final static int GPIO_INPUT_4 = 3; // номер GPIO (GPIO4: 3), соотв. входу 3
	final static int GPIO_INPUT_5 = 4; // номер GPIO (GPIO5: 4), соотв. входу 4

	final static int GPIO_OUTPUT_6 = 5; // номер GPIO (GPIO6: 5), соотв. выходу 5
	final static int GPIO_OUTPUT_7 = 6; // номер GPIO (GPIO7: 6), соотв. выходу 6
	final static int GPIO_OUTPUT_8 = 7; // номер GPIO (GPIO8: 7), соотв. выходу 7
	final static int GPIO_OUTPUT_9 = 8; // номер GPIO (GPIO9: 8), соотв. выходу 8
	final static int GPIO_OUTPUT_10 = 9; // номер GPIO (GPIO10: 9), соотв. выходу 9
	
	// Переменные класса 
	ATCommand		atCommand; // Создаем его здесь и раздаем разным членам.
	ATCommand		atCommandForTc65Io; // Отдельный - для работы с I/O, чтобы быстрее
	
//	MyATCommandListener atCommandListener; // слушает АТ-команды с СМС и др. событиями
//	MyATCommandListener atioCommandListener; // Для ТС65 (вход-выход)

	Tc65SerialPort	tc65SerialPort;
	Tc65Io		tc65Io;
	MenuSettings	menuSettings;
	SMSSendReceive  smsSendReceive;
	
	boolean Inputs[]; // Состояния входов, зарегистрированные при последнем чтении
	boolean InputsChanged[];

	// Отладочные переменные
	final static boolean CanSendSms = true; // false - не посылать СМС, для отладки

/********************************************************
 * Функция содержит вызовы задач, выполняемых однократно 
 * перед входом в рабочий цикл.
 ********************************************************/
	protected void RunOneTimeTasks()
	{
		// TODO: Добавляйте сюда свои задачи.

		// ТЗ: Выполнение какого либо блока команд, к примеру отправка СМС о старте
		String msg = "Программа upsControl запущена.";
		DebugOut("\n\rMessage: " + Translit.translit(msg) + "\n\r");
		if(CanSendSms)
			smsSendReceive.sendSMS(menuSettings.Number1, msg);
	}

	/********************************************************
	 * Функция содержит вызовы задач, выполняемых при  
	 * получении сообщения "!" 0x21
	 ********************************************************/
	protected void Execute0x21()
	{
		// TODO: Добавляйте сюда свои задачи.

		// Например: посылаем SMS о пропадании питания
		String msg = "ИБП сказал \"Пропало питание\" (0х21)";
		DebugOut("\n\rMessage: " + Translit.translit(msg) + "\n\r");
		if(CanSendSms)
			smsSendReceive.sendSMS(menuSettings.Number1, msg);
	}
	
	// TODO: Создавайте новые функции-обработчики по аналогии.
	
	/********************************************************
	 * Тело программы (точка входа) 
	 ********************************************************/
	public UpsControl() {
		try
		{
	        atCommand = new ATCommand(false);
	        atCommandForTc65Io = new ATCommand(false);
	        tc65SerialPort = new Tc65SerialPort();
	        // Меню будет давать АТ-команды в GPIO, а они будут 
	        // инициализироваться в отдельном парсере tc65Io. 
	        // Поэтому передаем в меню именно тот парсер.
	        menuSettings = new MenuSettings(tc65SerialPort, atCommandForTc65Io);
	        tc65Io = new Tc65Io(atCommandForTc65Io, menuSettings);
//	        atCommandListener = new MyATCommandListener(false, tc65Io, tc65SerialPort);
//	        atioCommandListener = new MyATCommandListener(true, tc65Io, tc65SerialPort);
	        smsSendReceive = new SMSSendReceive(atCommand, menuSettings);
	        
	        // Теперь наш atCommandListener должен реагировать на АТ-команды,
	        // пришедшие сами по себе (типа RING)
	        // Нас интересуют URC, пришедшие на АТ-парсер tc65Io
//	        tc65Io.atCommand.addListener(atioCommandListener);
//	        atCommand.addListener(atCommandListener);
	        
	        Inputs = new boolean[10];   
	        InputsChanged = new boolean[10];
	        
	        serialOut("UpsControl build 101226 SMTK R3\n\r");
		}
		catch(Exception e) 
		{
			System.out.println(e);
			notifyDestroyed();
		}
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		System.out.println("destroyApp(" + arg0 + ")");

        notifyDestroyed();    

	}

	protected void pauseApp() {

	}
	/**
	 * Wrappers for debug output to serial port
	 * @param str
	 */
	void serialOut(String str)
	{
		tc65SerialPort.serialOut(str.getBytes());
	}
	void serialOut(byte[] ar)
	{
		tc65SerialPort.serialOut(ar);
	}
	void DebugOut(String str)
	{
		if(menuSettings.DebugInfoToCOM)
			tc65SerialPort.serialOut(str.getBytes());
	}
	void DebugOut(byte[] ar)
	{
		if(menuSettings.DebugInfoToCOM)
			tc65SerialPort.serialOut(ar);
	}

	

	protected void startApp() throws MIDletStateChangeException {
//		ТЗ: Загрузка конфигурации из файла (значения переменных, К примеру номера тел.,
//		значения GPIO, параметры COM порта )

		// Запускаем поток работы с меню
        menuSettings.start();
		
        if(tc65Io.initIo() == true)
        	DebugOut("\n\rI/O initialized.\n\r");
        else
        	DebugOut("\n\rERROR initializing I/O!\n\r");
        
        if(CanSendSms == false)
        	serialOut("DEBUG BUILD, NO SMS ARE REALLY SENT! \n\r");

		// Ждем, пока меню разговаривает
		do
		{
        	try
        	{
        	Thread.sleep(1000);
        	}
        	catch(Exception e)
        	{
        		serialOut(e.toString());
        	}
		}
		while(menuSettings.isAlive());

		// Показываем, что отладочный вывод включен и будет мешать обмену 
		// данными - на это наступил человек. Если он выключен - ничего не будет видно и всё 
		// будет ОК.
 		DebugOut("Menu finished, continuing\n\r");
 		DebugOut("***************************************************\n\r" +
 				 "*             ATTENTION!!!                        *\n\r" +
 				 "* Debug output is ON. It means you will NOT get   *\n\r" +
 				 "* correct data exchange with your device.         *\n\r" +
 				 "* PLEASE TURN DEBUGGING OFF TO WORK WITH HARDWARE *\n\r" +
 				 "***************************************************\n\r" 
 				);
		char FirstCharOfNumber = menuSettings.Number1.charAt(0);
		if(FirstCharOfNumber != '+' && 
				FirstCharOfNumber != '8' )
		{
			serialOut("Telephone number is wrong or not set, cannot continue.\n\r"+
					"Restart the app and use menu to enter and save telephone number.\r\n");
			menuSettings.RetCode = menuSettings.MS_EXITPROG; // Выходим из программы
		}
 		
		if(menuSettings.RetCode == menuSettings.MS_EXITPROG)
		{
			DebugOut("Exiting program...\r\n");
			destroyApp(true);
		}
			
		if(menuSettings.PinWasEntered == false)
		{
			// Вводим PIN. Если ошибка - выходим.
			if(EnterPIN() == false)
			{
				serialOut("Error entering PIN, exiting app...\n\r");
		        destroyApp(true);
			}

			serialOut("\n\rPIN accepted, please wait 30 seconds to connect to GSM network service\n\r" );
        	try{Thread.sleep(30000);}catch(Exception e){serialOut(e.toString());}

		}

		// Initializing SMS sender
		smsSendReceive.init();

		// ТЗ: Выполнение какого либо блока команд, к примеру отправка СМС о старте
		serialOut("\n\rRunning one-time tasks..." );
		RunOneTimeTasks();
		
		serialOut("done.\n\rSetting serial port baudrate to " + Integer.toString(menuSettings.BaudRate) + "\n\r" );

		// Настраиваем СОМ-порт на заданную скорость
		tc65SerialPort.SetBaudRate(menuSettings.BaudRate);
		
		int SendoutTimer = millisNow(); // Учет времени отправки запросов в ИБП 
		boolean bExit = false;

		// Сбрасываем состояния входов
		Inputs[GPIO_INPUT_1] = tc65Io.inIo(GPIO_INPUT_1);
		Inputs[GPIO_INPUT_2] = tc65Io.inIo(GPIO_INPUT_2);
		Inputs[GPIO_INPUT_3] = tc65Io.inIo(GPIO_INPUT_3);
		Inputs[GPIO_INPUT_4] = tc65Io.inIo(GPIO_INPUT_4);
		Inputs[GPIO_INPUT_5] = tc65Io.inIo(GPIO_INPUT_5);
		for(int i=0; i<10; i++)
		{
			InputsChanged[i] = false;
		}
		
		// *************************************************************************
		// Почему-то здесь нельзя применять тип long, как только его применяешь, прога 
		// перестает говорить через СОМ-порт!!!
		// **************************************************************************

		StringBuffer sb = new StringBuffer(32); // Массив байтов, принятых в данном сообщении
		int nReceived = 0; // Количество байтов, принятых в данном сообщении
		int ResponseExpected = 0; // Не 0, если мы ожидаем ответа от ИБП
		int ResponseExpectMillis = 0; // Таймаут ожидания ответа
        while(bExit == false)
        {
        	// ТЗ: Ожидание сообщения по COM порту от ИБП (RS-232) 
        	nReceived = 0;
        	sb.delete(0, sb.length()); // Очищаем буфер
			// Получаем даныне из СОМ-порта модема
			while(tc65SerialPort.hasData() > 0)
			{
				sb.append((char)tc65SerialPort.readByte());
				nReceived++;
	        	// Ждем следующего байта в течение 100 мс
				try{Thread.sleep(200);}catch(Exception e){serialOut(e.toString());}
			}
			
			// ТЗ: В случае получения сообщения проверка данного сообщения на условия 
			if(nReceived > 0)
			{
				String s = sb.toString();
				
				DebugOut("Got " + Integer.toString(nReceived) + " bytes from UPS: " +
						s + "\n\r");
				
				// Если ИБП должен ответить на запрос, а мы - передать этот ответ через СМС
				if(ResponseExpected > 0)
				{
					switch(ResponseExpected)
					{
					case 1: //ТЗ:  Ожидаем ответа на запрос Internal temp
						//...и отправляем ответ по СМС "Internal temp = 036.0"
						DebugOut("Sending SMS: " + "Internal temp = " + s );
						if(CanSendSms)
							smsSendReceive.sendSMS(menuSettings.Number1, 
									"Internal temp = " + s );
						break;
					default:
						DebugOut("Sending SMS: " + "Unexpected response " + Integer.toString(ResponseExpected));
						if(CanSendSms)
							smsSendReceive.sendSMS(menuSettings.Number1, 
									"Unexpected response " + Integer.toString(ResponseExpected));
							break;
					}
					ResponseExpected = 0;
				}
				//ТЗ:  (к примеру при пропадании питания посылается сообщение "!" ASCII 0x21)
				if(s.charAt(0) == '!')
				{
					//ТЗ:  и выполнение блока команд или отсылка СМС.
					DebugOut("Got \"!\", exeecuting Execute0x21()\n\r");
					Execute0x21();
				}
				// TODO: Добавляйте сравнение строк и вызовы обработчиков сюда
			}
			
			// ТЗ: Для поддержания нормальной связи контроллера с ИБП APC
			// необходимо периодически раз в 30 секунд посылать ИБП команду "Y"
			if( (millisNow() - SendoutTimer) > 30000)
			{ 
				byte b = (byte)'Y';
				tc65SerialPort.writeByte(b);
				SendoutTimer = millisNow(); 
			}

			// ТЗ: Ожидание изменение сигнала на GPIO (1 или 0), при изменении 
			// проверка на условие и  выполнение блока команд или отсылка СМС
			boolean Input = tc65Io.inIo(GPIO_INPUT_1);
			if(Inputs[GPIO_INPUT_1] != Input)
			{
				// Если вход 1 изменился и сейчас он равен 1
				if(Input == true)
				{
					DebugOut("\n\rInput GPIO1 became 1, sending SMS\n\r");
					if(CanSendSms)
						smsSendReceive.sendSMS(menuSettings.Number1, "Вход 1 стал равен 1");
				}
				Inputs[GPIO_INPUT_1] = Input;
			}
			
			// TODO: Делаем проверки и действуем по аналогии
		
			// ТЗ: Ожидание получение СМС, при получении выполнение блока команд. 
			if(smsSendReceive.receiveSMS() == true)
			{
				String strSms = smsSendReceive.GetLastSms();
				DebugOut("Received SMS: " + strSms + " from " + 
						smsSendReceive.strLastSender + ", type " +
						Integer.toString(smsSendReceive.iLastSenderType) + 
						", at " + smsSendReceive.strLastSmsTime + "\n\r");
				//ТЗ:  На пример при получении текстового сообщения 
				// "Internal temp" отправляется команда на COM
				// порт  "C"  (ASCII код 0х43) получаем ответ "036.0" 
				// и отправляем ответ по СМС "Internal temp = 036.0"
				if(strSms.indexOf("Internal temp") != -1)
				{
					// Посылаем запрос в ИБП
					//byte b = (byte)'С';
					tc65SerialPort.writeByte((byte)0x43);//b);
					
					ResponseExpected = 1; // Ставим признак ожидания ответа от ИБП
					ResponseExpectMillis = millisNow();
				}
				//ТЗ: или при получении СМС "1 ON" подаем 3V на GPIO 1
				else if(strSms.indexOf("6 ON") != -1)
					tc65Io.outIo(GPIO_OUTPUT_6, true);
				else if(strSms.indexOf("6 OFF") != -1)
					tc65Io.outIo(GPIO_OUTPUT_6, false);
				else if(strSms.indexOf("7 ON") != -1)
					tc65Io.outIo(GPIO_OUTPUT_7, true);
				else if(strSms.indexOf("7 OFF") != -1)
					tc65Io.outIo(GPIO_OUTPUT_7, false);
				else if(strSms.indexOf("8 ON") != -1)
					tc65Io.outIo(GPIO_OUTPUT_8, true);
				else if(strSms.indexOf("8 OFF") != -1)
					tc65Io.outIo(GPIO_OUTPUT_8, false);
				else if(strSms.indexOf("9 ON") != -1)
					tc65Io.outIo(GPIO_OUTPUT_9, true);
				else if(strSms.indexOf("9 OFF") != -1)
					tc65Io.outIo(GPIO_OUTPUT_9, false);
				else if(strSms.indexOf("10 ON") != -1)
					tc65Io.outIo(GPIO_OUTPUT_10, true);
				else if(strSms.indexOf("10 OFF") != -1)
					tc65Io.outIo(GPIO_OUTPUT_10, false);
				//TODO: Добавляйте свои сравнения СМСов и действия:
				//else if(strSms.indexOf("???") != -1)
				//	tc65Io.outIo(GPIO_OUTPUT_???, true);
				//else if(strSms.indexOf("???") != -1)
				//	tc65Io.outIo(GPIO_OUTPUT_???, true);
				else
				{
					// Сообщаем о необработанном запросе
					DebugOut("Sending SMS about bad request\n\r");
					if(CanSendSms)
						smsSendReceive.sendSMS(menuSettings.Number1, "Запрос \"" + 
								strSms + "\" непонятный, не обработан");
				}
			}
			
			// Проверяем, не слишком ли долго мы ждем ответа от ИБП, и
			// посылаем СМС об ошибке
			if(ResponseExpected > 0 && // мы ждем какого-то ответа от ИБП 
					millisNow() - ResponseExpectMillis > 10000) // таймаут 10 секунд
			{
				DebugOut("Sending \"No response\" SMS (request was \"" + 
						Integer.toString(ResponseExpected) + "\")\n\r");
				if(CanSendSms)
					smsSendReceive.sendSMS(menuSettings.Number1, 
							"Не получен ответ от ИБП на запрос типа " + 
							Integer.toString(ResponseExpected));
				ResponseExpected = 0;
				ResponseExpectMillis = 0;
			}
        }
         
        // В принципе, сюда мы не попадем никогда.
        
        DebugOut("\n\rDestroying...\n\r");
        
//		io.outIo(0, false); // off

		tc65SerialPort.Close();

		destroyApp(true);
	}

	/****************************
	 * Ниже - служебные функции
	 *****************************/
	
	private boolean EnterPIN()
	{
		boolean bOkFound = false;
		
		if(menuSettings.PINCode.length() == 0)
		{
			DebugOut("PIN empty, will not be sent.\n\r" );
			return true;
		}
		
		// Если ПИН не цифровой - это не пин (или не настроен).
		// По умолчанию его не надо ставить.
		char ar[] = menuSettings.PINCode.toCharArray();
		boolean bIsNotPin = false;
		for(int i=0; i<menuSettings.PINCode.length(); i++)
		{
			if(ar[i] < '0' || ar[i] > '9')
				bIsNotPin = true;
		}
		if(bIsNotPin == true)
		{
			DebugOut("PIN is " + menuSettings.PINCode + "(not a PIN), will not be sent.\n\r" );
			return true;
		}
		
		DebugOut("PIN=" + menuSettings.PINCode + "\r\n" );
		String s = new String("(no command has been sent)");
		try{
		s = atCommand.send("AT+CPIN=" + menuSettings.PINCode + "\r");
		}
		catch(ATCommandFailedException e)
		{
			serialOut("Exception " + e.getMessage() + "\n\r" );
		}
		DebugOut("\r\nCommand:" + s + "\n\r" );
		
		if(s.indexOf("OK") > 0)
			bOkFound = true;
		
		return bOkFound;
	}
	
	// Чтобы в проге не нужно было использовать глюкавый long, делаем такую функцию.
	private int millisNow()
	{
		return (int)System.currentTimeMillis();
	}
}
